"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Visitor = require("./Visitor");

var _Visitor2 = _interopRequireDefault(_Visitor);

var _FileUtility = require("../util/FileUtility");

var _FileUtility2 = _interopRequireDefault(_FileUtility);

var _ReactTransformer = require("../docs/react/ReactTransformer");

var _ReactTransformer2 = _interopRequireDefault(_ReactTransformer);

var _CopyFiles = require("../docs/copy/CopyFiles");

var _CopyFiles2 = _interopRequireDefault(_CopyFiles);

var _Validation = require("../util/Validation");

var _Validation2 = _interopRequireDefault(_Validation);

var _Utility = require("../util/Utility");

var _Utility2 = _interopRequireDefault(_Utility);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Transformer = function () {
    function Transformer(root, configFilePath) {
        var _this = this;

        _classCallCheck(this, Transformer);

        this.pre = function (source) {

            if (!_this.root) {
                _this.__init(source.opts.sourceRoot, ".doc.gen.json");
            }
            var fileInformation = _FileUtility2.default.getInformation(source.opts.filename);

            var newHash = _Utility2.default.hash(source.code);
            if (!_this.hash[fileInformation.filePath]) {
                _this.setHash(fileInformation.filePath, newHash);
            } else if (_this.hash[fileInformation.filePath] === newHash) {
                return;
            }

            if (_this.reactTransformer) {
                _this.reactTransformer.transform(fileInformation, source.code);
            }

            if (_this.copyFiles) {
                _this.copyFiles.copy(fileInformation, source.code);
            }
            _this.setHash(fileInformation.filePath, newHash);
        };

        if (root) {
            if (!configFilePath) {
                configFilePath = ".doc.gen.json";
            }
            this.__init(root, configFilePath);
        }
    }

    _createClass(Transformer, [{
        key: "__init",
        value: function __init(root, configFilePath) {
            if (!this.root) {
                this.root = root;
                var configSource = _FileUtility2.default.readFile(this.root + "/" + configFilePath);
                this.config = JSON.parse(configSource);
                if (this.config.react) {
                    this.config.react.root = this.root;
                    this.reactTransformer = new _ReactTransformer2.default(this.config.react);
                }
                if (this.config.copy) {
                    this.config.copy.root = this.root;
                    this.copyFiles = new _CopyFiles2.default(this.config.copy);
                }
                if (!this.config.hashFile) {
                    this.config.hashFile = ".hash";
                }

                if (!_Validation2.default.startsWith(this.config.hashFile, "/")) {
                    this.config.hashFile = this.root + "/" + this.config.hashFile;
                }

                if (!_FileUtility2.default.isExist(this.config.hashFile)) {
                    _FileUtility2.default.createFile(this.config.hashFile, "{}");
                }
                this.hash = JSON.parse(_FileUtility2.default.readFile(this.config.hashFile));
            }
        }
    }, {
        key: "setHash",
        value: function setHash(key, hash) {
            if (!this.hash[key] || this.hash[key] !== hash) {
                this.hash[key] = hash;
                _FileUtility2.default.writeFile(this.config.hashFile, JSON.stringify(this.hash));
            }
        }
    }]);

    return Transformer;
}();

exports.default = Transformer;